# number-name

Converts a number into its name.

[See the demo here.](https://Temoto-kun.github.io/number-name)

## Why?

Inspired by [number-to-words](https://www.npmjs.com/package/number-to-words). Thinking I could improve on the code to include
[big integers](https://www.npmjs.com/package/big-integer), I looked for some info and found [Landon Curt Noll's Web page describing
the reconstructed English naming system of numbers](http://www.isthe.com/chongo/tech/math/number/howhigh.html). I decided to port
his [Perl script](http://www.isthe.com/chongo/tech/math/number/number) into JavaScript.

## Installation

Install via Yarn:

```shell script
yarn add @theoryofnekomata/number-name
```

## TODO

- [X] Implement stream support
- [X] Implement `BigInt` support
- [X] Fully localizable number systems (e.g. custom rules for combining fragments of number words)
- [ ] Optimizations for fractions.
- [ ] Implement other `fractionType`s, (only `lazy` (digits) is supported as of 0.2.0, e.g. `0.05` => `zero point zero five`,
      will implement `ratio` (`zero and five over one hundred`) and `part` (`zero and five hundredths`))
- [ ] Upon adding more features, update the unit tests as well.

Please star the repo if you find it useful in your projects.

## License

MIT. See [LICENSE file](./LICENSE) for details.
