import hundredTimes from './hundredTimes'

it('should exist', () => {
  expect(hundredTimes).toBeDefined()
})

it('should be a callable', () => {
  expect(typeof hundredTimes).toBe('function')
})

it('should accept 1 argument', () => {
  expect(hundredTimes).toHaveLength(1)
})

test.each`
  value | display  | name
  ${1}  | ${'100'} | ${'einhundert'}
  ${2}  | ${'200'} | ${'zweihundert'}
  ${3}  | ${'300'} | ${'dreihundert'}
  ${4}  | ${'400'} | ${'vierhundert'}
  ${5}  | ${'500'} | ${'fünfhundert'}
  ${6}  | ${'600'} | ${'sechshundert'}
  ${7}  | ${'700'} | ${'siebenhundert'}
  ${8}  | ${'800'} | ${'achthundert'}
  ${9}  | ${'900'} | ${'neunhundert'}
`('should return "$name" on $display', ({ value, name }) => {
  expect(hundredTimes(value)).toBe(name)
})
