import tensFn from './tens'

it('should exist', () => {
  expect(tensFn).toBeDefined()
})

it('should be a callable', () => {
  expect(typeof tensFn).toBe('function')
})

it('should accept 2 arguments', () => {
  expect(tensFn).toHaveLength(2)
})

describe('on 0 in tens place', () => {
  test.each`
    ones | onesName
    ${0} | ${'zero'}
    ${1} | ${'ein'}
    ${2} | ${'zwei'}
    ${3} | ${'drei'}
    ${4} | ${'vier'}
    ${5} | ${'fünf'}
    ${6} | ${'sechs'}
    ${7} | ${'sieben'}
    ${8} | ${'acht'}
    ${9} | ${'neun'}
  `(`should return "$onesName" for $ones`, ({ ones, onesName }) => {
    expect(tensFn(0, ones)).toBe(onesName)
  })
})

describe('on 1 in tens place', () => {
  test.each`
    ones | tenPlusName
    ${0} | ${'zehn'}
    ${1} | ${'elf'}
    ${2} | ${'zwölf'}
    ${3} | ${'dreizehn'}
    ${4} | ${'vierzehn'}
    ${5} | ${'fünfzehn'}
    ${6} | ${'sechzehn'}
    ${7} | ${'siebzehn'}
    ${8} | ${'achtzehn'}
    ${9} | ${'neunzehn'}
  `(`should return "$tenPlusName" for 1$ones`, ({ ones, tenPlusName }) => {
    expect(tensFn(1, ones)).toBe(tenPlusName)
  })
})

describe.each`
  tens | tensName
  ${2} | ${'zwanzig'}
  ${3} | ${'dreißig'}
  ${4} | ${'vierzig'}
  ${5} | ${'fünfzig'}
  ${6} | ${'sechzig'}
  ${7} | ${'siebzig'}
  ${8} | ${'achtzig'}
  ${9} | ${'neunzig'}
`('on $tens in tens place', ({ tens, tensName }) => {
  test.each`
    ones | display
    ${0} | ${'' + tensName}
    ${1} | ${'einund' + tensName}
    ${2} | ${'zweiund' + tensName}
    ${3} | ${'dreiund' + tensName}
    ${4} | ${'vierund' + tensName}
    ${5} | ${'fünfund' + tensName}
    ${6} | ${'sechsund' + tensName}
    ${7} | ${'siebenund' + tensName}
    ${8} | ${'achtund' + tensName}
    ${9} | ${'neunund' + tensName}
  `(`should return "$display" for ${tens}$ones`, ({ ones, display }) => {
    expect(tensFn(tens, ones)).toBe(display)
  })
})
