import { Digit } from '../../../common'
import NAMES from '../names'
import ones from '../base/ones'
import tenPlus from '../base/tenPlus'
import getBaseTenTimesName from '../base/tenTimes'

interface Tens {
  (x10: Digit, x1: Digit): string
}

const tens: Tens = (x10, x1) => {
  switch (x10) {
    case 0:
      return ones(x1)
    case 1:
      if (x1 > 0) {
        return tenPlus(x1)
      }
      break
    default:
      break
  }

  return x1 > 0 ? [ones(x1), NAMES.and, getBaseTenTimesName(x10)].join('') : getBaseTenTimesName(x10)
}

export default tens
