import { Digit } from '../../../common'
import NAMES from '../names'

interface HundredTimes {
  (x100: Digit): string
}

/**
 * Get the name of some number in the hundreds place.
 * @param {number} x100 - The number in the hundreds place.
 * @returns {string} The name of the number in the hundreds place.
 */
const hundredTimes: HundredTimes = (x100) =>
  x100 === 0 ? NAMES.units[0] : [NAMES.units[x100], NAMES.hundred].join(' ')

export default hundredTimes
