import ones from './ones'

it('should exist', () => {
  expect(ones).toBeDefined()
})

it('should be a callable', () => {
  expect(typeof ones).toBe('function')
})

it('should accept a minimum of 1 argument', () => {
  expect(ones).toHaveLength(1)
})

describe('on ordinary units', () => {
  test.each`
    value | display | name
    ${0}  | ${'0'}  | ${''}
    ${1}  | ${'1'}  | ${'un'}
    ${2}  | ${'2'}  | ${'duo'}
    ${3}  | ${'3'}  | ${'tre'}
    ${4}  | ${'4'}  | ${'quattuor'}
    ${5}  | ${'5'}  | ${'quin'}
    ${6}  | ${'6'}  | ${'sex'}
    ${7}  | ${'7'}  | ${'septen'}
    ${8}  | ${'8'}  | ${'octo'}
    ${9}  | ${'9'}  | ${'novem'}
  `('should return "$name" on $display', ({ value, name }) => {
    expect(ones(value, false)).toBe(name)
  })
})

describe('on special units', () => {
  test.each`
    value | display | name
    ${0}  | ${'0'}  | ${''}
    ${1}  | ${'1'}  | ${'m'}
    ${2}  | ${'2'}  | ${'b'}
    ${3}  | ${'3'}  | ${'tr'}
    ${4}  | ${'4'}  | ${'quadr'}
    ${5}  | ${'5'}  | ${'quin'}
    ${6}  | ${'6'}  | ${'sex'}
    ${7}  | ${'7'}  | ${'sept'}
    ${8}  | ${'8'}  | ${'oct'}
    ${9}  | ${'9'}  | ${'non'}
  `('should return "$name" on $display', ({ value, name }) => {
    expect(ones(value, true)).toBe(name)
  })
})
