import { Digit } from '../../../common'
import NAMES from '../names'

interface TenTimes {
  (x10: Digit): string
}

/**
 * Get the name of some number in the tens place.
 * @param {number} x10 - The number in the tens place.
 * @returns {string} The name of the number in the tens place.
 */
const tenTimes: TenTimes = (x10) => NAMES.tenTimes[x10]

export default tenTimes
