import tensFn from './tens'

it('should exist', () => {
  expect(tensFn).toBeDefined()
})

it('should be a callable', () => {
  expect(typeof tensFn).toBe('function')
})

it('should accept 2 arguments', () => {
  expect(tensFn).toHaveLength(2)
})

describe('on 0 in tens place', () => {
  test.each`
    ones | onesName
    ${0} | ${'zero'}
    ${1} | ${'one'}
    ${2} | ${'two'}
    ${3} | ${'three'}
    ${4} | ${'four'}
    ${5} | ${'five'}
    ${6} | ${'six'}
    ${7} | ${'seven'}
    ${8} | ${'eight'}
    ${9} | ${'nine'}
  `(`should return "$onesName" for $ones`, ({ ones, onesName }) => {
    expect(tensFn(0, ones)).toBe(onesName)
  })
})

describe('on 1 in tens place', () => {
  test.each`
    ones | tenPlusName
    ${0} | ${'ten'}
    ${1} | ${'eleven'}
    ${2} | ${'twelve'}
    ${3} | ${'thirteen'}
    ${4} | ${'fourteen'}
    ${5} | ${'fifteen'}
    ${6} | ${'sixteen'}
    ${7} | ${'seventeen'}
    ${8} | ${'eighteen'}
    ${9} | ${'nineteen'}
  `(`should return "$tenPlusName" for 1$ones`, ({ ones, tenPlusName }) => {
    expect(tensFn(1, ones)).toBe(tenPlusName)
  })
})

describe.each`
  tens | tensName
  ${2} | ${'twenty'}
  ${3} | ${'thirty'}
  ${4} | ${'forty'}
  ${5} | ${'fifty'}
  ${6} | ${'sixty'}
  ${7} | ${'seventy'}
  ${8} | ${'eighty'}
  ${9} | ${'ninety'}
`('on $tens in tens place', ({ tens, tensName }) => {
  test.each`
    ones | onesName
    ${0} | ${''}
    ${1} | ${' one'}
    ${2} | ${' two'}
    ${3} | ${' three'}
    ${4} | ${' four'}
    ${5} | ${' five'}
    ${6} | ${' six'}
    ${7} | ${' seven'}
    ${8} | ${' eight'}
    ${9} | ${' nine'}
  `(`should return "${tensName}$onesName" for ${tens}$ones`, ({ ones, onesName }) => {
    expect(tensFn(tens, ones)).toBe([tensName, onesName].join(''))
  })
})
