import getKiloCount from './getKiloCount'

it('should exist', () => {
  expect(getKiloCount).toBeDefined()
})

it('should be a callable', () => {
  expect(typeof getKiloCount).toBe('function')
})

it('should accept 3 arguments', () => {
  expect(getKiloCount).toHaveLength(3)
})

describe.each`
  hundreds | hundredsName
  ${1}     | ${'one hundred'}
  ${2}     | ${'two hundred'}
  ${3}     | ${'three hundred'}
  ${4}     | ${'four hundred'}
  ${5}     | ${'five hundred'}
  ${6}     | ${'six hundred'}
  ${7}     | ${'seven hundred'}
  ${8}     | ${'eight hundred'}
  ${9}     | ${'nine hundred'}
`('on $hundreds in hundreds place', ({ hundreds, hundredsName }) => {
  describe('on 0 in tens place', () => {
    test.each`
      ones | onesName
      ${0} | ${''}
      ${1} | ${' one'}
      ${2} | ${' two'}
      ${3} | ${' three'}
      ${4} | ${' four'}
      ${5} | ${' five'}
      ${6} | ${' six'}
      ${7} | ${' seven'}
      ${8} | ${' eight'}
      ${9} | ${' nine'}
    `(`should return "${hundredsName}$onesName" for ${hundreds}0$ones`, ({ ones, onesName }) => {
      expect(getKiloCount(hundreds, 0, ones)).toBe([hundredsName, onesName].join(''))
    })
  })

  describe('on 1 in tens place', () => {
    test.each`
      ones | tenPlusName
      ${0} | ${' ten'}
      ${1} | ${' eleven'}
      ${2} | ${' twelve'}
      ${3} | ${' thirteen'}
      ${4} | ${' fourteen'}
      ${5} | ${' fifteen'}
      ${6} | ${' sixteen'}
      ${7} | ${' seventeen'}
      ${8} | ${' eighteen'}
      ${9} | ${' nineteen'}
    `(`should return "${hundredsName}$tenPlusName" for ${hundreds}1$ones`, ({ ones, tenPlusName }) => {
      expect(getKiloCount(hundreds, 1, ones)).toBe([hundredsName, tenPlusName].join(''))
    })
  })

  describe.each`
    tens | tensName
    ${2} | ${' twenty'}
    ${3} | ${' thirty'}
    ${4} | ${' forty'}
    ${5} | ${' fifty'}
    ${6} | ${' sixty'}
    ${7} | ${' seventy'}
    ${8} | ${' eighty'}
    ${9} | ${' ninety'}
  `('on $tens in tens place', ({ tens, tensName }) => {
    test.each`
      ones | onesName
      ${0} | ${''}
      ${1} | ${' one'}
      ${2} | ${' two'}
      ${3} | ${' three'}
      ${4} | ${' four'}
      ${5} | ${' five'}
      ${6} | ${' six'}
      ${7} | ${' seven'}
      ${8} | ${' eight'}
      ${9} | ${' nine'}
    `(`should return "${hundredsName}${tensName}$onesName" for ${hundreds}${tens}$ones`, ({ ones, onesName }) => {
      expect(getKiloCount(hundreds, tens, ones)).toBe([hundredsName, tensName, onesName].join(''))
    })
  })
})
