import getLongKiloName from './getLongKiloName'

it('should exist', () => {
  expect(getLongKiloName).toBeDefined()
})

it('should be a callable', () => {
  expect(typeof getLongKiloName).toBe('function')
})

it('should accept 1 argument', () => {
  expect(getLongKiloName).toHaveLength(1)
})

test.each`
  thousandPower | name
  ${0n}         | ${''}
  ${1n}         | ${'thousand'}
  ${2n}         | ${'million'}
  ${3n}         | ${'thousand million'}
  ${4n}         | ${'billion'}
  ${5n}         | ${'thousand billion'}
  ${6n}         | ${'trillion'}
  ${7n}         | ${'thousand trillion'}
  ${8n}         | ${'quadrillion'}
  ${9n}         | ${'thousand quadrillion'}
  ${10n}        | ${'quintillion'}
  ${11n}        | ${'thousand quintillion'}
  ${12n}        | ${'sextillion'}
  ${13n}        | ${'thousand sextillion'}
  ${14n}        | ${'septillion'}
  ${15n}        | ${'thousand septillion'}
  ${16n}        | ${'octillion'}
  ${17n}        | ${'thousand octillion'}
  ${18n}        | ${'nonillion'}
  ${19n}        | ${'thousand nonillion'}
`('should return "$name" for 1000^$thousandPower', ({ name, thousandPower }) => {
  expect(getLongKiloName(thousandPower)).toBe(name)
})

test.each`
  thousandPower | name
  ${20n}        | ${'decillion'}
  ${40n}        | ${'vigintillion'}
  ${60n}        | ${'trigintillion'}
  ${80n}        | ${'quadragintillion'}
  ${100n}       | ${'quinquagintillion'}
  ${120n}       | ${'sexagintillion'}
  ${140n}       | ${'septuagintillion'}
  ${160n}       | ${'octogintillion'}
  ${180n}       | ${'nonagintillion'}
`('should return "$name" for 1000^$thousandPower', ({ name, thousandPower }) => {
  expect(getLongKiloName(thousandPower)).toBe(name)
})

test.each`
  thousandPower | name
  ${200n}       | ${'centillion'}
  ${400n}       | ${'duocentillion'}
  ${600n}       | ${'trecentillion'}
  ${800n}       | ${'quadringentillion'}
  ${1000n}      | ${'quingentillion'}
  ${1200n}      | ${'sescentillion'}
  ${1400n}      | ${'septingentillion'}
  ${1600n}      | ${'octingentillion'}
  ${1800n}      | ${'nongentillion'}
`('should return "$name" for 1000^$thousandPower', ({ name, thousandPower }) => {
  expect(getLongKiloName(thousandPower)).toBe(name)
})

test.each`
  thousandPower | name
  ${2000n}      | ${'milliatillion'}
  ${4000n}      | ${'duomilliatillion'}
  ${6000n}      | ${'tremilliatillion'}
  ${8000n}      | ${'quattuormilliatillion'}
  ${10000n}     | ${'quinmilliatillion'}
  ${12000n}     | ${'sexmilliatillion'}
  ${14000n}     | ${'septenmilliatillion'}
  ${16000n}     | ${'octomilliatillion'}
  ${18000n}     | ${'novemmilliatillion'}
`('should return "$name" for 1000^$thousandPower', ({ name, thousandPower }) => {
  expect(getLongKiloName(thousandPower)).toBe(name)
})

test.each`
  thousandPower | name
  ${20000n}     | ${'decmilliatillion'}
  ${40000n}     | ${'viginmilliatillion'}
  ${60000n}     | ${'triginmilliatillion'}
  ${80000n}     | ${'quadraginmilliatillion'}
  ${100000n}    | ${'quinquaginmilliatillion'}
  ${120000n}    | ${'sexaginmilliatillion'}
  ${140000n}    | ${'septuaginmilliatillion'}
  ${160000n}    | ${'octoginmilliatillion'}
  ${180000n}    | ${'nonaginmilliatillion'}
`('should return "$name" for 1000^$thousandPower', ({ name, thousandPower }) => {
  expect(getLongKiloName(thousandPower)).toBe(name)
})

test.each`
  thousandPower | name
  ${200000n}    | ${'cenmilliatillion'}
  ${400000n}    | ${'duocenmilliatillion'}
  ${600000n}    | ${'trecenmilliatillion'}
  ${800000n}    | ${'quadringenmilliatillion'}
  ${1000000n}   | ${'quingenmilliatillion'}
  ${1200000n}   | ${'sescenmilliatillion'}
  ${1400000n}   | ${'septingenmilliatillion'}
  ${1600000n}   | ${'octingenmilliatillion'}
  ${1800000n}   | ${'nongenmilliatillion'}
`('should return "$name" for 1000^$thousandPower', ({ name, thousandPower }) => {
  expect(getLongKiloName(thousandPower)).toBe(name)
})

test.each`
  thousandPower | name
  ${2000000n}   | ${'milliamilliatillion'}
  ${4000000n}   | ${'duomilliamilliatillion'}
  ${6000000n}   | ${'tremilliamilliatillion'}
  ${8000000n}   | ${'quattuormilliamilliatillion'}
  ${10000000n}  | ${'quinmilliamilliatillion'}
  ${12000000n}  | ${'sexmilliamilliatillion'}
  ${14000000n}  | ${'septenmilliamilliatillion'}
  ${16000000n}  | ${'octomilliamilliatillion'}
  ${18000000n}  | ${'novemmilliamilliatillion'}
`('should return "$name" for 1000^$thousandPower', ({ name, thousandPower }) => {
  expect(getLongKiloName(thousandPower)).toBe(name)
})
