import getShortKiloName from './getShortKiloName'

it('should exist', () => {
  expect(getShortKiloName).toBeDefined()
})

it('should be a callable', () => {
  expect(typeof getShortKiloName).toBe('function')
})

it('should accept 1 argument', () => {
  expect(getShortKiloName).toHaveLength(1)
})

test.each`
  thousandPower | name
  ${0n}         | ${''}
  ${1n}         | ${'thousand'}
  ${2n}         | ${'million'}
  ${3n}         | ${'billion'}
  ${4n}         | ${'trillion'}
  ${5n}         | ${'quadrillion'}
  ${6n}         | ${'quintillion'}
  ${7n}         | ${'sextillion'}
  ${8n}         | ${'septillion'}
  ${9n}         | ${'octillion'}
  ${10n}        | ${'nonillion'}
`('should return "$name" for 1000^$thousandPower', ({ name, thousandPower }) => {
  expect(getShortKiloName(thousandPower)).toBe(name)
})

test.each`
  thousandPower | name
  ${11n}        | ${'decillion'}
  ${21n}        | ${'vigintillion'}
  ${31n}        | ${'trigintillion'}
  ${41n}        | ${'quadragintillion'}
  ${51n}        | ${'quinquagintillion'}
  ${61n}        | ${'sexagintillion'}
  ${71n}        | ${'septuagintillion'}
  ${81n}        | ${'octogintillion'}
  ${91n}        | ${'nonagintillion'}
`('should return "$name" for 1000^$thousandPower', ({ name, thousandPower }) => {
  expect(getShortKiloName(thousandPower)).toBe(name)
})

test.each`
  thousandPower | name
  ${101n}       | ${'centillion'}
  ${201n}       | ${'duocentillion'}
  ${301n}       | ${'trecentillion'}
  ${401n}       | ${'quadringentillion'}
  ${501n}       | ${'quingentillion'}
  ${601n}       | ${'sescentillion'}
  ${701n}       | ${'septingentillion'}
  ${801n}       | ${'octingentillion'}
  ${901n}       | ${'nongentillion'}
`('should return "$name" for 1000^$thousandPower', ({ name, thousandPower }) => {
  expect(getShortKiloName(thousandPower)).toBe(name)
})

test.each`
  thousandPower | name
  ${1001n}      | ${'milliatillion'}
  ${2001n}      | ${'duomilliatillion'}
  ${3001n}      | ${'tremilliatillion'}
  ${4001n}      | ${'quattuormilliatillion'}
  ${5001n}      | ${'quinmilliatillion'}
  ${6001n}      | ${'sexmilliatillion'}
  ${7001n}      | ${'septenmilliatillion'}
  ${8001n}      | ${'octomilliatillion'}
  ${9001n}      | ${'novemmilliatillion'}
`('should return "$name" for 1000^$thousandPower', ({ name, thousandPower }) => {
  expect(getShortKiloName(thousandPower)).toBe(name)
})

test.each`
  thousandPower | name
  ${10001n}     | ${'decmilliatillion'}
  ${20001n}     | ${'viginmilliatillion'}
  ${30001n}     | ${'triginmilliatillion'}
  ${40001n}     | ${'quadraginmilliatillion'}
  ${50001n}     | ${'quinquaginmilliatillion'}
  ${60001n}     | ${'sexaginmilliatillion'}
  ${70001n}     | ${'septuaginmilliatillion'}
  ${80001n}     | ${'octoginmilliatillion'}
  ${90001n}     | ${'nonaginmilliatillion'}
`('should return "$name" for 1000^$thousandPower', ({ name, thousandPower }) => {
  expect(getShortKiloName(thousandPower)).toBe(name)
})

test.each`
  thousandPower | name
  ${100001n}    | ${'cenmilliatillion'}
  ${200001n}    | ${'duocenmilliatillion'}
  ${300001n}    | ${'trecenmilliatillion'}
  ${400001n}    | ${'quadringenmilliatillion'}
  ${500001n}    | ${'quingenmilliatillion'}
  ${600001n}    | ${'sescenmilliatillion'}
  ${700001n}    | ${'septingenmilliatillion'}
  ${800001n}    | ${'octingenmilliatillion'}
  ${900001n}    | ${'nongenmilliatillion'}
`('should return "$name" for 1000^$thousandPower', ({ name, thousandPower }) => {
  expect(getShortKiloName(thousandPower)).toBe(name)
})

test.each`
  thousandPower | name
  ${1000001n}   | ${'milliamilliatillion'}
  ${2000001n}   | ${'duomilliamilliatillion'}
  ${3000001n}   | ${'tremilliamilliatillion'}
  ${4000001n}   | ${'quattuormilliamilliatillion'}
  ${5000001n}   | ${'quinmilliamilliatillion'}
  ${6000001n}   | ${'sexmilliamilliatillion'}
  ${7000001n}   | ${'septenmilliamilliatillion'}
  ${8000001n}   | ${'octomilliamilliatillion'}
  ${9000001n}   | ${'novemmilliamilliatillion'}
`('should return "$name" for 1000^$thousandPower', ({ name, thousandPower }) => {
  expect(getShortKiloName(thousandPower)).toBe(name)
})
