import { NumberSystem } from '../../common'
import getKiloCount from './getKiloCount'
import getLongKiloName from './getLongKiloName'
import getEuropeanLongKiloName from './getEuropeanLongKiloName'
import getShortKiloName from './getShortKiloName'
import joinKilo from './joinKilo'

const numberSystem: NumberSystem = {
  getKiloCount,
  getKiloName: {
    short: getShortKiloName,
    long: getLongKiloName,
    europeanLong: getEuropeanLongKiloName,
  },
  joinKilo,
}

export default numberSystem
